// ExcelKittingTemplate.cpp: CExcelKittingTemplate NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "workscheduler.h"
#include "ExcelKittingTemplate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// GNZJ
static CExcelFile::SColumnInfo s_aColumnInfo[] = {
//	̫	^								ŏ			ő			L
	{NULL,	eDataTypeNone,			1,		0,		0,				0,				"123"},		// 폜׸
	{NULL,	eDataTypeNone,			1,		0,		0,				0,				"123"},		// ǉ׸
	{NULL,	eDataTypeAlphaNumKana,	32,		0,		0,				0,				NULL},		// ײݖ
	{NULL,	eDataTypeAlphaNum,		80,		0,		0,				0,				NULL},		// HL
	{NULL,	eDataTypeAlphaNum,		32,		0,		0,				0,				NULL},		// Hԍ
	{NULL,	eDataTypeKoteiName,		128,	0,		0,				0,				NULL},		// H
	{NULL,	eDataTypeKoteiName,		128,	0,		0,				0,				NULL},		// vfƌQ
	{NULL,	eDataTypeAll,			6,		0,		0,				0,				NULL},		// ^蓮(vfƌQ)
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL},		// Ǝ
	{NULL,	eDataTypeNumber,		8,		0,		0,				9999,			NULL},		// No.
	{NULL,	eDataTypeAll,			128,	0,		0,				0,				NULL},		// Ɠe
	{NULL,	eDataTypeNumber,		8,		0,		0,				0,				NULL},		// vfNo.
	{NULL,	eDataTypeAlphaNum,		/*8*/32,0,		0,				0,				"/*+-"},	// Z
	{"1",	eDataTypeNumber,		10,		4,		-9999.9999,		9999.9999,		NULL},		// S1
	{"1",	eDataTypeNumber,		10,		4,		-9999.9999,		9999.9999,		NULL},		// S2
	{"1",	eDataTypeNumber,		10,		4,		-9999.9999,		9999.9999,		NULL},		// M
	{"1",	eDataTypeNumber,		10,		4,		-9999.9999,		9999.9999,		NULL},		// N
	{"0",	eDataTypeNumber,		12,		6,		-9999.999999,	9999.999999,	NULL},		// Z̍Ǝ
	{"1",	eDataTypeNumber,		4,		0,		1,				9999,			NULL},		// px
	{"0",	eDataTypeNumber,		4,		0,		0,				9999,			NULL},		// JԂ
	{"0",	eDataTypeNumber,		21,		6,		0,				9999.999999,	NULL},		// 䂠̗vfƖƎ
	{NULL,	eDataTypeAll,			256,	0,		0,				0,				NULL},		// 
	{NULL,	eDataTypeNone,			1,		0,		0,				0,				"1"},		// ޯߍH
	{NULL,	eDataTypeAll,			6,		0,		0,				0,				NULL},		// ^蓮(H)
	{NULL,	eDataTypeNumber,		12,		0,		0,				999999999999,	NULL},		// vfƌQ
	{NULL,	eDataTypeNone,			2,		0,		0,				0,				"Yy"},		// FMEA׸
	{NULL,	eDataTypeNone,			2,		0,		0,				0,				"Yy"},		// _׸
	{NULL,	eDataTypeAll,			32,		0,		0,				0,				NULL},		// _px
	{NULL,	eDataTypeAll,			6,		0,		0,				0,				NULL},		// Œ蕔/ϓ׸
	{NULL,	eDataTypeNone,			2,		0,		0,				0,				"Yy"},		// ׸
	{NULL,	eDataTypeAll,			10,		0,		0,				0,				NULL},		// ׸
	{NULL,	eDataTypeAll,			1,		0,		0,				0,				NULL},		// -҂׸
	{NULL,	eDataTypeAll,			1,		0,		0,				0,				NULL},		// (1)orH(2)׸
	{NULL,	eDataTypeNumber,		21,		0,		0,				0,				NULL},		// ԍ
	{NULL,	eDataTypeNumber,		21,		6,		0,				9999.999999,	NULL},		// v
	{NULL,	eDataTypeNumber,		21,		6,		0,				9999.999999,	NULL},		// ƌQv
	{NULL,	eDataTypeNumber,		21,		6,		0,				9999.999999,	NULL},		// 䗦vZƌQv
	{NULL,	eDataTypeNumber,		21,		6,		0,				9999.1000000,	NULL},		// HvW
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				9999.1000000,	NULL},		// ʒu(ԍ)
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL},		// ݼ݌(L)
	{NULL,	eDataTypeAlphaNum,		256,	0,		0,				0,				NULL},		// pNo
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL},		// dNo
	{NULL,	eDataTypeNone,			1,		0,		0,				0,				"1234"},	// 敪
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL},		// ˑ䍂
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL},		// گč
	{"0",	eDataTypeNone,			1,		0,		0,				0,				"01"},		// ͑u
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL},		// ݔ(/)
	{NULL,	eDataTypeAlphaNum,		64,		0,		0,				0,				NULL}		// H(/d)
};

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CExcelKittingTemplate::CExcelKittingTemplate()
{
	m_sFileName = "";
	m_pColumnInfo = s_aColumnInfo;
	m_nColumnInfo = sizeof(s_aColumnInfo) / sizeof(CExcelFile::SColumnInfo);
	m_nFileNo = 8;
}

BOOL CExcelKittingTemplate::AccessCheck(LPCTSTR pFolderName)
{
	return FileAccessCheck(pFolderName, m_sFileName, TRUE);
}

BOOL CExcelKittingTemplate::ReadFile()
{
	if (!CExcelFile::ReadFile())
		return FALSE;

	GetKishuCols(eColSagyosha);
	GetKishuCols(eColYosoSagyogunJunban);
	GetKishuCols(eColSagyogunGokeiJikan);
	GetKishuCols(eColHiritsukeisangoSagyogunGokeiJikan);

	return TRUE;
}

BOOL CExcelKittingTemplate::FileDataCheck()
{
	CString sData;
	BOOL bError = FALSE;
	_variant_t vEmpty;

	SetCurrentSheet(0);

	// sɂ郋[v
	int nUsedRows = GetUsedRows();
	for (int nRow = 3; nRow <= nUsedRows; nRow++) {
		GetElement(nRow, eColSublineName, sData);
		if (sData.CollateNoCase("kitting") == 0) {
			// ɂ郋[v
			for (int i = 0; i < m_nColumnInfo; i++) {
				SColumnInfo *pColumnInfo = m_pColumnInfo + i;
				int nCol = GetColumnNo(i + 1);

				// f[^擾
				GetElement(nRow, nCol, sData);

				// G[`FbN
				if (!sData.IsEmpty()) {
					if ((pColumnInfo->cDataCheck.m_nDataType != eDataTypeNumber && !pColumnInfo->cDataCheck.LengthCheck(sData))
							|| !pColumnInfo->cDataCheck.ValidCharCheck(sData)
							|| !pColumnInfo->cDataCheck.RangeCheck(sData)) {
						// G[O
						ErrorFileLog("͒ls", nRow, nCol);

						// G[ȂftHglZbg
						if (pColumnInfo->pDefault == NULL)
							PutElement(nRow, nCol, vEmpty);
						else
							PutElement(nRow, nCol, pColumnInfo->pDefault);

						bError = TRUE;
					}
				}
			}
		}
	}

	return !bError;
}
