//*****************************************************************************************************
//  1. t@C
//		WorkSchedulerDlg.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CAboutDlg,CWorkSchedulerDlg NX̃Cve[V
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "WorkScheduler.h"

#include "MenuDispCtrl.h"

#include "WorkSchedulerDlg001.h"
#include "WorkSchedulerDlg.h"
#include "AboutDlg.h"
#include "DataManager.h"
#include "StartMenuDlg.h"
#include "SaveProjectDlg.h"
#include "SetConditionsDlg.h"
#include "AutoSchedulingDlg.h"
#include "ManualSchedulingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MENU_START				0
#define MENU_SET_CONDITIONS		1
#define MENU_AUTO_SCHEDULING	2
#define MENU_MANUAL_SCHEDULING	3

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::CWorkSchedulerDlg
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd		*pParent			[I] eEBhE
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		\[XACR擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
CWorkSchedulerDlg::CWorkSchedulerDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CWorkSchedulerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWorkSchedulerDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWorkSchedulerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWorkSchedulerDlg)
	DDX_Control(pDX, IDC_PROGRESS_BAR, m_cProgressBar);
	DDX_Control(pDX, IDC_STATIC_STATUS, m_cStaticStatus);
	DDX_Control(pDX, IDC_BUTTON_EXIT, m_buttonExit);
	DDX_Control(pDX, IDC_BUTTON_AUTO_SCHEDULING, m_buttonAutoScheduling);
	DDX_Control(pDX, IDC_BUTTON_MANUAL_SCHEDULING, m_buttonManualScheduling);
	DDX_Control(pDX, IDC_BUTTON_SET_CONDITIONS, m_buttonSetConditions);
	DDX_Control(pDX, IDC_BUTTON_START, m_buttonStart);
	DDX_Control(pDX, IDC_STATIC_CHILD_MENU, m_cSubMenu);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWorkSchedulerDlg, CDialogEx)
	//{{AFX_MSG_MAP(CWorkSchedulerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_SET_CONDITIONS, OnButtonSetConditions)
	ON_BN_CLICKED(IDC_BUTTON_AUTO_SCHEDULING, OnButtonAutoScheduling)
	ON_BN_CLICKED(IDC_BUTTON_MANUAL_SCHEDULING, OnButtonManualScheduling)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, OnButtonExit)
	ON_COMMAND(IDM_FILE_SAVE, OnFileSave)
	ON_COMMAND(IDM_FILE_SAVE_AS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(IDM_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(IDM_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDM_HELP_VERSION, OnHelpVersion)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_OPEN_EXCEL, OnOpenExcel)
	ON_MESSAGE(WM_CLOSE_EXCEL, OnCloseExcel)
	ON_MESSAGE(WM_ERROR_EXCEL, OnErrorExcel)
END_MESSAGE_MAP()

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^ǗNX𐶐Aj[ATuj[A{^B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CWorkSchedulerDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

// Modify ... ( CHANGE )
	// ^CgɃo[Wԍǉ
	CString sWindowVersion;
	int j = 0;
	for( int i = 0; i < g_pConst->m_sVersion.GetLength(); i++ ){
		if( g_pConst->m_sVersion[i] == '.' ){
			j++;
			if( j == 2 ){
				sWindowVersion.Format("%s", g_pConst->m_sVersion.Left(i) );
				break;
			}
		}
	}
/*	CString sWindowTitle, sWindowTitle2;
	GetWindowText(sWindowTitle);
	sWindowTitle2.Format("%s (Ver.%s)", sWindowTitle, g_pConst->m_sVersion);
	SetWindowText(sWindowTitle2);*/
// By Y.Itabashi (xxxxx) 2007.01.25

// Modify ... ( ADD )
	sprintf( Menu_WorkSchedulerDlg[0].str1, "%s", sWindowVersion );
	g_pSystem->m_cMenuDisp.SetMenuText( this, Menu_WorkSchedulerDlg );
// By Y.Itabashi (xxxxx) 2007.01.24

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
//		CString strAboutMenu;
//		strAboutMenu.LoadString(IDS_ABOUTBOX);
//		if (!strAboutMenu.IsEmpty())
//		{
//			pSysMenu->AppendMenu(MF_SEPARATOR);
//			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
//		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	InitMenuButton();
	InitSubMenu();
	EnableMenu();

// Modify ... ( ADD )
	g_pSystem->m_cMenuDisp.SetMenuText( this, Menu_WorkSchedulerMenu );
// By Y.Itabashi (xxxxx) 2007.01.26

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CWorkSchedulerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CWorkSchedulerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CWorkSchedulerDlg::OnQueryDragIcon()
{
	return (HCURSOR)m_hIcon;
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::InitMenuButton
//----------------------------------------------------------------------------------------------------
//  2. @\
//		j[{^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		j[{^zɓA{^̐Fݒ肷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::InitMenuButton()
{
	// j[{^zɐݒ
	m_arrayMenuButton.Add(&m_buttonStart);
	m_arrayMenuButton.Add(&m_buttonSetConditions);
	m_arrayMenuButton.Add(&m_buttonAutoScheduling);
	m_arrayMenuButton.Add(&m_buttonManualScheduling);
	m_arrayMenuButton.Add(&m_buttonExit);

	// {^̐Fݒ
	int nSize = m_arrayMenuButton.GetSize();
	for (int i = 0; i < nSize; i++)
		m_arrayMenuButton[i]->SetBackGroundColor(COLOR_MENU_BUTTON);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::InitSubMenu
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Tuj[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Tuj[̃_CAOzɓAuҐJnvIԂɂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::InitSubMenu()
{
	// Tuj[̃_CAOzɐݒ
	m_cSubMenu.Add(new CStartMenuDlg, IDD_START_MENU);
	m_cSubMenu.Add(new CSetConditionsDlg, IDD_SET_CONDITIONS);
	m_cSubMenu.Add(new CAutoSchedulingDlg, IDD_AUTO_SCHEDULING);
	m_cSubMenu.Add(new CManualSchedulingDlg, IDD_MANUAL_SCHEDULING);

	// uҐJnvI
	SelectMenu(MENU_START);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::SelectMenu
//----------------------------------------------------------------------------------------------------
//  2. @\
//		j[I
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nIndex			[I] I郁j[̃CfbNX
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		SẴj[{^̑IAw肳ꂽj[{^IԂɂA
//		Tuj[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::SelectMenu(int nIndex)
{
	// IԂ
	int nSize = m_arrayMenuButton.GetSize();
	for (int i = 0; i < nSize; i++) {
		if (m_arrayMenuButton[i]->GetCheck() != 0) {
			m_arrayMenuButton[i]->SetCheck(0);
			m_arrayMenuButton[i]->Invalidate();
		}
	}

	// w肳ꂽj[{^IԂɐݒ
	m_arrayMenuButton[nIndex]->SetCheck(1);
	m_arrayMenuButton[nIndex]->Invalidate();

	// Tuj[\
	m_cSubMenu.Show(nIndex);

	// Xe[^Xo[ɕ\
	m_arrayMenuButton[nIndex]->GetWindowText(m_sMainStatus);
	m_cStaticStatus.SetWindowText(m_sMainStatus);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::EnableMenu
//----------------------------------------------------------------------------------------------------
//  2. @\
//		j[{^̗Lݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Xe[^Xɂ胁j[{^̗L^ݒ肷B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::EnableMenu()
{
	// Ґݒ{^
	m_buttonSetConditions.EnableWindow(g_pDataManager->m_nStatus >= STATUS_READ_DATA);

	// Ґs{^
	m_buttonAutoScheduling.EnableWindow(g_pDataManager->m_nStatus >= STATUS_SEISAN_JOKEN && !g_pDataManager->m_bOpenLineKiseiMatrix && !g_pDataManager->m_bOpenKatashikiKiseiMatrix);

	// 蓮Ґ{^
	BOOL bSagyoshaWaritsuke = FALSE;
	int nSublineNum = g_pDataManager->GetSublineNum();
	for (int nSublineId = 0; nSublineId < nSublineNum; nSublineId++) {
		SSubline *pSubline = g_pDataManager->GetSublineData(nSublineId);
		if (pSubline->bSagyoshaWaritsuke) {
			bSagyoshaWaritsuke = TRUE;
			break;
		}
	}
	m_buttonManualScheduling.EnableWindow(g_pDataManager->m_nStatus >= STATUS_SEISAN_JOKEN && bSagyoshaWaritsuke);

	// Tuj[̃{^
	m_cSubMenu.EnableMenu();
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::SetSubMenuStatus
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Tuj[ɂXe[^X\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pText			[I] Xe[^Xo[ɕ\eLXg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽeLXgXe[^Xo[ɕ\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::SetSubMenuStatus(LPCTSTR pText)
{
	m_cStaticStatus.SetWindowText(m_sMainStatus + "F" + pText);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::SetSubMenuStatus
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Tuj[ɂXe[^X\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd		&wndButton			[I] Tuj[{^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽTuj[{^̃eLXgXe[^Xo[ɕ\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::SetSubMenuStatus(CWnd &wndButton)
{
	CString sText;
	wndButton.GetWindowText(sText);
	SetSubMenuStatus(sText);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::ClearSubMenuStatus
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Tuj[̃Xe[^X
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		Xe[^Xo[Tuj[̃eLXgB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::ClearSubMenuStatus()
{
	m_cStaticStatus.SetWindowText(m_sMainStatus);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnButtonStart
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uҐJnv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ҐJnTuj[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnButtonStart()
{
	SelectMenu(MENU_START);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnButtonSetConditions
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uҐݒv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ҐݒTuj[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnButtonSetConditions()
{
	SelectMenu(MENU_SET_CONDITIONS);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnButtonAutoScheduling
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uҐsv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ҐsTuj[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnButtonAutoScheduling()
{
	SelectMenu(MENU_AUTO_SCHEDULING);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnButtonManualScheduling
//----------------------------------------------------------------------------------------------------
//  2. @\
//		u蓮Ґv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		蓮ҐTuj[\B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnButtonManualScheduling()
{
	SelectMenu(MENU_MANUAL_SCHEDULING);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnButtonExit
//----------------------------------------------------------------------------------------------------
//  2. @\
//		uIv{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		vfƕ\XVĂꍇ͕ۑAvOIB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnButtonExit()
{
	if (!g_pSystem->m_bReadOnly && g_pDataManager->m_bUpdate) {
		if (g_pSystem->DispMessage("Q030001") == IDYES)
			g_pDataManager->SaveFile();
	}

	if (g_pSystem->DispMessage("Q030002") == IDYES)
		DestroyWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnFileSave
//----------------------------------------------------------------------------------------------------
//  2. @\
//		㏑ۑ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		vfƕ\㏑ۑB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnFileSave()
{
	g_pSystem->m_Save_mode = 1;	//2007/02/10 xxxxx kuwa

	if (g_pSystem->DispMessage("Q003003") == IDYES) {
		if (g_pDataManager->SaveFile())
			g_pSystem->DispMessage("I003004");
	}
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnFileSaveAs
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otĕۑ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		t@Cۑ_CAO\A͂ꂽt@Cŗvfƕ\ۑB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnFileSaveAs()
{
	g_pSystem->m_Save_mode = 2;	//2007/02/10 xxxxx kuwa

	CSaveProjectDlg dlg;
	if (dlg.DoModal() == IDOK)
		g_pSystem->DispMessage("I002005");
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnCancel
//----------------------------------------------------------------------------------------------------
//  2. @\
//		LZ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		IƓB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnCancel()
{
#ifdef _DEBUG
	DestroyWindow();
#else
	OnButtonExit();
#endif
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnUpdateFileSave
//----------------------------------------------------------------------------------------------------
//  2. @\
//		㏑ۑj[Lݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CCmdUI		*pCmdUI			[I] CCmdUIIuWFNg|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		GNZt@Cǂ܂ĂΏ㏑ۑj[LɂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnUpdateFileSave(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(g_pDataManager->m_nStatus != STATUS_NOREAD && !g_pSystem->m_bReadOnly);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnUpdateFileSaveAs
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Otĕۑj[Lݒ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CCmdUI		*pCmdUI			[I] CCmdUIIuWFNg|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		GNZt@Cǂ܂ĂΖOtĕۑj[LɂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CWorkSchedulerDlg::OnUpdateFileSaveAs(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(g_pDataManager->m_nStatus != STATUS_NOREAD);
}

//*****************************************************************************************************
//  1. ֐
//		CWorkSchedulerDlg::OnInitMenuPopup
//----------------------------------------------------------------------------------------------------
//  2. @\
//		j[\nh
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CMenu		*pPopupMenu		[I] j[IuWFNg|C^
//		UINT		nIndex			[I] j[CfbNX
//		BOOL		bSysMenu		[I] VXej[tO
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		_CAOOnUpdate**nhLɂ邽߂̏B
//----------------------------------------------------------------------------------------------------
//  6. l
//		MFCFrameWndNXRs[
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
// j[\nh
void CWorkSchedulerDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	CDialogEx::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

	// [artifact]CMainFramẽoϐ m_bAutoMenuEnable ̑ɒ`B
	// true ȂftHgŃj[ԂɂȂB
	bool bAutoMenuEnable = true;

//	AfxCancelModes(m_hWnd);

	if (bSysMenu)
		return; // don't support system menu

	ASSERT(pPopupMenu != NULL);
	// check the enabled state of various menu items

	CCmdUI state;
	state.m_pMenu = pPopupMenu;
	ASSERT(state.m_pOther == NULL);
	ASSERT(state.m_pParentMenu == NULL);

	// determine if menu is popup in top-level menu and set m_pOther to
	//  it if so (m_pParentMenu == NULL indicates that it is secondary popup)
	HMENU hParentMenu;
	if (AfxGetThreadState()->m_hTrackingMenu == pPopupMenu->m_hMenu)
		state.m_pParentMenu = pPopupMenu; // parent == child for tracking popup
	else if ((hParentMenu = ::GetMenu(m_hWnd)) != NULL)
	{
		CWnd* pParent = GetTopLevelParent();
		// child windows don't have menus -- need to go to the top!
		if (pParent != NULL &&
			(hParentMenu = ::GetMenu(pParent->m_hWnd)) != NULL)
		{
			int nIndexMax = ::GetMenuItemCount(hParentMenu);
			for (int nIndex = 0; nIndex < nIndexMax; nIndex++)
			{
				if (::GetSubMenu(hParentMenu, nIndex) == pPopupMenu->m_hMenu)
				{
					// when popup is found, m_pParentMenu is containing menu
					state.m_pParentMenu = CMenu::FromHandle(hParentMenu);
					break;
				}
			}
		}
	}

	state.m_nIndexMax = pPopupMenu->GetMenuItemCount();
	for (state.m_nIndex = 0; state.m_nIndex < state.m_nIndexMax;
			state.m_nIndex++)
	{
		state.m_nID = pPopupMenu->GetMenuItemID(state.m_nIndex);
		if (state.m_nID == 0)
			continue; // menu separator or invalid cmd - ignore it

		ASSERT(state.m_pOther == NULL);
		ASSERT(state.m_pMenu != NULL);
		if (state.m_nID == (UINT)-1)
		{
			// possibly a popup menu, route to first item of that popup
			state.m_pSubMenu = pPopupMenu->GetSubMenu(state.m_nIndex);
			if (state.m_pSubMenu == NULL ||
				(state.m_nID = state.m_pSubMenu->GetMenuItemID(0)) == 0 ||
				state.m_nID == (UINT)-1)
			{
				continue;       // first item of popup can't be routed to
			}
			state.DoUpdate(this, FALSE);    // popups are never auto disabled
		}
		else
		{
			// normal menu item
			// Auto enable/disable if frame window has 'm_bAutoMenuEnable'
			//    set and command is _not_ a system command.
			state.m_pSubMenu = NULL;
			state.DoUpdate(this, bAutoMenuEnable && state.m_nID < 0xF000);
		}

		// adjust for menu deletions and additions
		UINT nCount = pPopupMenu->GetMenuItemCount();
		if (nCount < state.m_nIndexMax)
		{
			state.m_nIndex -= (state.m_nIndexMax - nCount);
			while (state.m_nIndex < nCount &&
				pPopupMenu->GetMenuItemID(state.m_nIndex) == state.m_nID)
			{
				state.m_nIndex++;
			}
		}
		state.m_nIndexMax = nCount;
	}
}

void CWorkSchedulerDlg::OnHelpVersion()
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

void CWorkSchedulerDlg::PostNcDestroy()
{
	CDialogEx::PostNcDestroy();

	delete this;
}

LRESULT CWorkSchedulerDlg::OnOpenExcel(WPARAM wParam, LPARAM lParam)
{
	g_pDataManager->OpenExcelNotify(wParam);

	EnableMenu();

	return 0;
}

LRESULT CWorkSchedulerDlg::OnCloseExcel(WPARAM wParam, LPARAM lParam)
{
	g_pDataManager->CloseExcelNotify(wParam);

	EnableMenu();

	return 0;
}

LRESULT CWorkSchedulerDlg::OnErrorExcel(WPARAM wParam, LPARAM lParam)
{
	g_pDataManager->ErrorExcelNotify(wParam);

	EnableMenu();

	return 0;
}

// EnterL[Ń_CAO̂}~
void CWorkSchedulerDlg::OnOK()
{
}
